(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     25294,        709]
NotebookOptionsPosition[     21996,        640]
NotebookOutlinePosition[     22420,        657]
CellTagsIndexPosition[     22377,        654]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
   RowBox[{"CellContext", "\[Rule]", "Notebook"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.83637182481455*^9, 3.836371824815637*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"6490e92c-354d-4b7d-bbda-9fa6bc118791"],

Cell[BoxData[
 RowBox[{"Import", "[", 
  "\"\<https://raw.githubusercontent.com/zwicker-group/MathematicaToPython/\
master/ToPython.wl\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.836371070591913*^9, 3.83637109729657*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"d8ccbffb-7fdc-4cd0-800f-608fd7fe2321"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cs", "=", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]", ",", "\[Tau]"}], "}"}]}], ";", 
  RowBox[{"css", "=", 
   RowBox[{"ToString", "/@", "cs"}]}]}]], "Input",
 CellChangeTimes->{{3.836369954315196*^9, 3.836369960763295*^9}, 
   3.8363718310778503`*^9, 3.836444302749177*^9, {3.913696834676597*^9, 
   3.913696837944214*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"27cf09c3-e0f9-44f9-9397-fc6f153aa1ac"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"\[Sigma]\"\>", ",", "\<\"\[Tau]\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8363699658626347`*^9, 3.8363700422911*^9, {3.836370976064389*^9, 
   3.8363709774311533`*^9}, 3.836371623652684*^9, {3.836371827054821*^9, 
   3.836371848038763*^9}, 3.836444304948358*^9, 3.83654340647231*^9, 
   3.836550790866767*^9, 3.837079737338674*^9, 3.913689001450231*^9, 
   3.913696839253376*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"62f3e841-7a67-4bd4-9e8c-46dd96831a07"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basis Vectors", "Section",
 CellChangeTimes->{{3.913688115897051*^9, 
  3.913688118927403*^9}},ExpressionUUID->"3e17dceb-56db-4825-b4d2-\
aead3443ec73"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoordinateChartData", "[", 
  RowBox[{"\"\<Bipolar\>\"", ",", "\"\<Metric\>\"", ",", "cs"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.913688122317361*^9, 3.913688165576187*^9}, {
  3.9136886379837513`*^9, 3.91368865964395*^9}, {3.913689005007164*^9, 
  3.913689011821822*^9}, {3.9136968426560698`*^9, 3.9136968435888367`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"3bb0ce92-7e26-4ba7-91c7-23e8bd17e2c2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[FormalA]", "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
         RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]], ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     FractionBox[
      SuperscriptBox["\[FormalA]", "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
         RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.913688166163424*^9, {3.913688654930982*^9, 3.913688659918107*^9}, {
   3.913689005779591*^9, 3.913689024342724*^9}, 3.913696844321246*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"c257aa12-36a3-4a3c-a2a8-4b3837eb9365"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoordinateChartData", "[", 
  RowBox[{"\"\<Bipolar\>\"", ",", "\"\<ScaleFactors\>\"", ",", "cs"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.913688174138687*^9, 3.913688176820921*^9}, {
  3.913688662328278*^9, 3.9136886657315073`*^9}, {3.913689015540304*^9, 
  3.9136890217764683`*^9}, {3.913696847876676*^9, 3.913696848658845*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"16e00b88-f168-4f5c-8157-6d83d957ad20"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["\[FormalA]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
     RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]], ",", 
   FractionBox["\[FormalA]", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
     RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.913688177081411*^9, 3.913688666137925*^9, 
  3.913689025087322*^9, 3.9136968488732567`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"a1c48cc6-6b0c-481e-8b85-3963c1a9a405"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoordinateTransformData", "[", 
  RowBox[{
   RowBox[{"\"\<Cartesian\>\"", "->", "\"\<Bipolar\>\""}], ",", 
   "\"\<Mapping\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"X", ",", "Y"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.913690517767449*^9, 3.913690532735682*^9}, {
  3.913696852554645*^9, 3.913696861163907*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"4e9c3e8b-4778-4009-93af-13ec0e254075"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["\[FormalA]", "2"]}], "+", 
      SuperscriptBox["X", "2"], "+", 
      SuperscriptBox["Y", "2"]}], ",", 
     RowBox[{"2", " ", "\[FormalA]", " ", "Y"}]}], "]"}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"\[FormalA]", "+", "X"}], ")"}], "2"], "+", 
       SuperscriptBox["Y", "2"]}], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[FormalA]"}], "+", "X"}], ")"}], "2"], "+", 
       SuperscriptBox["Y", "2"]}]], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.9136905330334263`*^9, {3.9136968538287897`*^9, 3.9136968613568497`*^9}},
 CellLabel->"Out[7]=",ExpressionUUID->"66fdebff-75ca-4207-bb81-c7cde41a8002"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoordinateTransformData", "[", 
  RowBox[{
   RowBox[{"\"\<Bipolar\>\"", "->", "\"\<Cartesian\>\""}], ",", 
   "\"\<Mapping\>\"", ",", "cs"}], "]"}]], "Input",
 CellChangeTimes->{{3.913688229628529*^9, 3.913688273096972*^9}, {
  3.913688668288845*^9, 3.913688673291135*^9}, {3.9136890172638693`*^9, 
  3.9136890278957872`*^9}, {3.913696866805455*^9, 3.913696867837953*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"692a6dc2-8f92-4789-9775-18319639b955"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"\[FormalA]", " ", 
     RowBox[{"Sinh", "[", "\[Tau]", "]"}]}], 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
     RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]], ",", 
   FractionBox[
    RowBox[{"\[FormalA]", " ", 
     RowBox[{"Sin", "[", "\[Sigma]", "]"}]}], 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
     RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.913688273943963*^9, 3.913688673599258*^9, {3.913689028295845*^9, 
   3.913689039129825*^9}, 3.91369686811938*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"3e4da200-193e-4ac5-a044-aad4a2a6be66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "@", 
  RowBox[{"Transpose", "@", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TransformedField", "[", 
      RowBox[{
       RowBox[{"\"\<Cartesian\>\"", "->", "\"\<Bipolar\>\""}], ",", "vec", 
       ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "Y"}], "}"}], "->", "cs"}]}], "]"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"vec", ",", " ", 
       RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.913688377013722*^9, 3.9136884821591177`*^9}, {
  3.913688675981019*^9, 3.91368870134344*^9}, {3.913689018359234*^9, 
  3.9136890574808817`*^9}, {3.913695182620275*^9, 3.9136952185112753`*^9}, {
  3.913696872566474*^9, 3.913696876944713*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"dc054213-15c8-467e-8834-24a033cc350b"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[FormalA]", " ", 
         RowBox[{"Sin", "[", "\[Sigma]", "]"}], " ", 
         RowBox[{"Sinh", "[", "\[Tau]", "]"}]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
           RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]]}], 
      FractionBox[
       RowBox[{"\[FormalA]", "-", 
        RowBox[{"\[FormalA]", " ", 
         RowBox[{"Cos", "[", "\[Sigma]", "]"}], " ", 
         RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
          RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]]},
     {
      FractionBox[
       RowBox[{"\[FormalA]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Sigma]", "]"}], " ", 
           RowBox[{"Cosh", "[", "\[Tau]", "]"}]}]}], ")"}]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
          RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[FormalA]", " ", 
         RowBox[{"Sin", "[", "\[Sigma]", "]"}], " ", 
         RowBox[{"Sinh", "[", "\[Tau]", "]"}]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
           RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"]]}]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.913688406639083*^9, 3.9136884824149227`*^9}, 
   3.913688701658168*^9, {3.913689035295871*^9, 3.91368905783214*^9}, {
   3.913695206692582*^9, 3.9136952187268248`*^9}, 3.913696877154483*^9},
 CellLabel->
  "Out[9]//MatrixForm=",ExpressionUUID->"3001b8a3-c518-48a0-981e-\
c8669d8e65c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TransformedField", "[", 
  RowBox[{
   RowBox[{"\"\<Bipolar\>\"", "->", "\"\<Cartesian\>\""}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "1"}], "}"}], ",", 
   RowBox[{"cs", "->", 
    RowBox[{"{", 
     RowBox[{"X", ",", "Y"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.913693091346294*^9, 3.913693105459991*^9}, {
  3.913693180421484*^9, 3.913693194763062*^9}, {3.913695292312161*^9, 
  3.913695311603877*^9}, {3.913696882016047*^9, 3.9136968863808413`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"4ff212b4-4e47-4747-b5ff-f12bd6b723bc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", "r", " ", "X", " ", "Y"}], 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["\[FormalA]", "2"], " ", 
        SuperscriptBox["Y", "2"]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[FormalA]", "2"]}], "+", 
          SuperscriptBox["X", "2"], "+", 
          SuperscriptBox["Y", "2"]}], ")"}], "2"]}]]], "-", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[FormalA]", "2"], "-", 
      SuperscriptBox["X", "2"], "+", 
      SuperscriptBox["Y", "2"]}], 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["\[FormalA]", "2"], " ", 
        SuperscriptBox["Y", "2"]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[FormalA]", "2"]}], "+", 
          SuperscriptBox["X", "2"], "+", 
          SuperscriptBox["Y", "2"]}], ")"}], "2"]}]]]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{"2", " ", "X", " ", "Y"}], 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["\[FormalA]", "2"], " ", 
        SuperscriptBox["Y", "2"]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[FormalA]", "2"]}], "+", 
          SuperscriptBox["X", "2"], "+", 
          SuperscriptBox["Y", "2"]}], ")"}], "2"]}]]], "+", 
    FractionBox[
     RowBox[{"r", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[FormalA]", "2"], "-", 
        SuperscriptBox["X", "2"], "+", 
        SuperscriptBox["Y", "2"]}], ")"}]}], 
     SqrtBox[
      RowBox[{
       RowBox[{"4", " ", 
        SuperscriptBox["\[FormalA]", "2"], " ", 
        SuperscriptBox["Y", "2"]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[FormalA]", "2"]}], "+", 
          SuperscriptBox["X", "2"], "+", 
          SuperscriptBox["Y", "2"]}], ")"}], "2"]}]]]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.9136930917436323`*^9, 3.913693105689433*^9}, 
   3.913693195085362*^9, 3.913695312045068*^9, 3.913696886695092*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"a15e0dca-62af-4102-9b6a-bfa2b71bded0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Scalar fields", "Section",
 CellChangeTimes->{{3.836371867491858*^9, 
  3.836371871207691*^9}},ExpressionUUID->"752a9a5b-318b-4b33-a799-\
2b60b3ff4b06"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Grad", "[", 
   RowBox[{
    RowBox[{"s", "[", 
     RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], ",", "cs", ",", 
    "\"\<Bipolar\>\""}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.8363699708374*^9, 3.836369985165965*^9}, 
   3.8363701599949017`*^9, 3.8363718394927673`*^9, {3.8364443223270197`*^9, 
   3.836444322466217*^9}, {3.913698495510807*^9, 3.913698507183242*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"78c971c1-e81c-4e91-b5ae-b2af0866856f"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
           RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], " ", 
         RowBox[{
          SuperscriptBox["s", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"1", ",", "0"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "\[FormalA]"]},
      {
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", "\[Sigma]", "]"}]}], "+", 
           RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], " ", 
         RowBox[{
          SuperscriptBox["s", 
           TagBox[
            RowBox[{"(", 
             RowBox[{"0", ",", "1"}], ")"}],
            Derivative],
           MultilineFunction->None], "[", 
          RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "\[FormalA]"]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.836369985555266*^9, {3.836370074172127*^9, 3.836370125015613*^9}, 
   3.836370160217512*^9, 3.8363709775676527`*^9, 3.836371625581029*^9, 
   3.8363718574480762`*^9, {3.836444309431652*^9, 3.836444322915578*^9}, 
   3.836543406561528*^9, 3.836550790897451*^9, 3.837079737368115*^9, 
   3.913698507939839*^9},
 CellLabel->
  "Out[11]//MatrixForm=",ExpressionUUID->"01f6b734-266e-4d28-996b-\
5f49e9bcdd26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "@", 
  RowBox[{"Laplacian", "[", 
   RowBox[{
    RowBox[{"s", "[", 
     RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], ",", "cs", ",", 
    "\"\<Bipolar\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8363701285502*^9, 3.836370135842626*^9}, 
   3.8363718395019627`*^9, {3.836444330307044*^9, 3.836444330361224*^9}, {
   3.913698521727002*^9, 3.913698530971493*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"bb39561b-7268-4107-8e1d-157174194579"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
      RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["s", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"0", ",", "2"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], "+", 
     RowBox[{
      SuperscriptBox["s", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"2", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], ")"}]}], 
  SuperscriptBox["\[FormalA]", "2"]]], "Output",
 CellChangeTimes->{
  3.836370136147089*^9, 3.836370977648357*^9, 3.836371860450674*^9, 
   3.8364443306135473`*^9, 3.836543406664468*^9, 3.836550790941704*^9, 
   3.837079737400285*^9, {3.913698527292067*^9, 3.91369853117507*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"98edcda4-7219-4990-85e9-c853701398b9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Vector fields", "Section",
 CellChangeTimes->{{3.836371875544259*^9, 
  3.83637187964915*^9}},ExpressionUUID->"10a6a951-c2ec-4510-9025-\
b114352779c7"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vec", "[", 
   RowBox[{"\[Sigma]_", ",", "\[Tau]_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Subscript", "[", 
      RowBox[{"f", ",", "i"}], "]"}], "[", 
     RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "css"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"vec", "[", 
  RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.8363699901621637`*^9, 3.836370104025691*^9}, {
  3.836444333482431*^9, 3.8364443378693123`*^9}, {3.836548719072796*^9, 
  3.836548720829526*^9}, {3.913698540001526*^9, 3.9136985519733477`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"a8d2c5cb-fb65-4db0-8825-4b0e42b073d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["f", "\<\"\[Sigma]\"\>"], "[", 
    RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], ",", 
   RowBox[{
    SubscriptBox["f", "\<\"\[Tau]\"\>"], "[", 
    RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.836370104413557*^9, 3.836370977514279*^9, 
  3.836371624654104*^9, 3.836371850274251*^9, 3.836371891488089*^9, 
  3.836444338210415*^9, 3.836543406951395*^9, 3.83654872244847*^9, 
  3.836548864580715*^9, 3.836550790987589*^9, 3.837079737446371*^9, 
  3.913698552365741*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"3382bc7a-276f-4228-9a24-f26c5e7d992e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vecDiv", "=", 
  RowBox[{"FullSimplify", "@", 
   RowBox[{"Div", "[", 
    RowBox[{
     RowBox[{"vec", "[", 
      RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], ",", "cs", ",", 
     "\"\<Bipolar\>\""}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.836369987083974*^9, 3.836369988094116*^9}, {
   3.836370077016363*^9, 3.836370081951086*^9}, {3.836371637099867*^9, 
   3.836371641271962*^9}, 3.8363718394976807`*^9, {3.8364443409514093`*^9, 
   3.8364443433218327`*^9}, {3.836444482907802*^9, 3.836444485794238*^9}, {
   3.9136985555435343`*^9, 3.9136985594556093`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"34922ada-c7b6-4ba1-8293-d801a26bbd09"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", "\[Sigma]", "]"}], " ", 
     RowBox[{
      SubscriptBox["f", "\<\"\[Sigma]\"\>"], "[", 
      RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"Sinh", "[", "\[Tau]", "]"}], " ", 
     RowBox[{
      SubscriptBox["f", "\<\"\[Tau]\"\>"], "[", 
      RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Sigma]", "]"}], "-", 
       RowBox[{"Cosh", "[", "\[Tau]", "]"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         SubscriptBox["f", "\<\"\[Tau]\"\>"], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"0", ",", "1"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}], "+", 
       RowBox[{
        SuperscriptBox[
         SubscriptBox["f", "\<\"\[Sigma]\"\>"], 
         TagBox[
          RowBox[{"(", 
           RowBox[{"1", ",", "0"}], ")"}],
          Derivative],
         MultilineFunction->None], "[", 
        RowBox[{"\[Sigma]", ",", "\[Tau]"}], "]"}]}], ")"}]}]}], 
   "\[FormalA]"]}]], "Output",
 CellChangeTimes->{{3.8363700821985693`*^9, 3.836370125387701*^9}, 
   3.836370977609374*^9, {3.83637162606951*^9, 3.8363716415076847`*^9}, 
   3.8363718590892973`*^9, 3.836371892137411*^9, {3.836444341396282*^9, 
   3.8364443435950108`*^9}, 3.83644448622211*^9, 3.8365434070061703`*^9, 
   3.836548865050107*^9, 3.836550791017046*^9, 3.837079737494597*^9, 
   3.9136985602000923`*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"3ed03d91-78c4-49e7-85f4-9581b9d6c819"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1512, 916},
WindowMargins->{{-1512, Automatic}, {173, Automatic}},
CellContext->Notebook,
FrontEndVersion->"13.2 for Mac OS X ARM (64-bit) (January 30, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"3d33f588-1e23-4944-aacf-5781e056e981"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 317, 6, 30, "Input",ExpressionUUID->"6490e92c-354d-4b7d-bbda-9fa6bc118791"],
Cell[878, 28, 300, 5, 30, "Input",ExpressionUUID->"d8ccbffb-7fdc-4cd0-800f-608fd7fe2321"],
Cell[CellGroupData[{
Cell[1203, 37, 436, 10, 30, "Input",ExpressionUUID->"27cf09c3-e0f9-44f9-9397-fc6f153aa1ac"],
Cell[1642, 49, 509, 9, 34, "Output",ExpressionUUID->"62f3e841-7a67-4bd4-9e8c-46dd96831a07"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2188, 63, 158, 3, 67, "Section",ExpressionUUID->"3e17dceb-56db-4825-b4d2-aead3443ec73"],
Cell[CellGroupData[{
Cell[2371, 70, 429, 7, 30, "Input",ExpressionUUID->"3bb0ce92-7e26-4ba7-91c7-23e8bd17e2c2"],
Cell[2803, 79, 886, 26, 59, "Output",ExpressionUUID->"c257aa12-36a3-4a3c-a2a8-4b3837eb9365"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3726, 110, 434, 7, 30, "Input",ExpressionUUID->"16e00b88-f168-4f5c-8157-6d83d957ad20"],
Cell[4163, 119, 578, 15, 52, "Output",ExpressionUUID->"a1c48cc6-6b0c-481e-8b85-3963c1a9a405"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4778, 139, 424, 9, 30, "Input",ExpressionUUID->"4e9c3e8b-4778-4009-93af-13ec0e254075"],
Cell[5205, 150, 939, 28, 63, "Output",ExpressionUUID->"66fdebff-75ca-4207-bb81-c7cde41a8002"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6181, 183, 475, 8, 30, "Input",ExpressionUUID->"692a6dc2-8f92-4789-9775-18319639b955"],
Cell[6659, 193, 732, 20, 55, "Output",ExpressionUUID->"3e4da200-193e-4ac5-a044-aad4a2a6be66"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7428, 218, 893, 21, 73, "Input",ExpressionUUID->"dc054213-15c8-467e-8834-24a033cc350b"],
Cell[8324, 241, 2340, 64, 91, "Output",ExpressionUUID->"3001b8a3-c518-48a0-981e-c8669d8e65c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10701, 310, 574, 12, 30, "Input",ExpressionUUID->"4ff212b4-4e47-4747-b5ff-f12bd6b723bc"],
Cell[11278, 324, 2347, 71, 65, "Output",ExpressionUUID->"a15e0dca-62af-4102-9b6a-bfa2b71bded0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13674, 401, 158, 3, 67, "Section",ExpressionUUID->"752a9a5b-318b-4b33-a799-2b60b3ff4b06"],
Cell[CellGroupData[{
Cell[13857, 408, 505, 10, 30, "Input",ExpressionUUID->"78c971c1-e81c-4e91-b5ae-b2af0866856f"],
Cell[14365, 420, 1953, 56, 95, "Output",ExpressionUUID->"01f6b734-266e-4d28-996b-5f49e9bcdd26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16355, 481, 481, 10, 30, "Input",ExpressionUUID->"bb39561b-7268-4107-8e1d-157174194579"],
Cell[16839, 493, 1071, 31, 61, "Output",ExpressionUUID->"98edcda4-7219-4990-85e9-c853701398b9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17959, 530, 157, 3, 67, "Section",ExpressionUUID->"10a6a951-c2ec-4510-9025-b114352779c7"],
Cell[CellGroupData[{
Cell[18141, 537, 750, 17, 52, "Input",ExpressionUUID->"a8d2c5cb-fb65-4db0-8825-4b0e42b073d2"],
Cell[18894, 556, 655, 14, 34, "Output",ExpressionUUID->"3382bc7a-276f-4228-9a24-f26c5e7d992e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19586, 575, 670, 13, 30, "Input",ExpressionUUID->"34922ada-c7b6-4ba1-8293-d801a26bbd09"],
Cell[20259, 590, 1709, 46, 59, "Output",ExpressionUUID->"3ed03d91-78c4-49e7-85f4-9581b9d6c819"]
}, Open  ]]
}, Open  ]]
}
]
*)

